# coding: utf-8

"""
    kraken

    The core component of kraken-project

    The version of the OpenAPI document: 0.1.0
    Contact: git@omikron.dev
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, StrictInt, StrictStr, field_validator
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class FullServiceDetectionResult(BaseModel):
    """
    A simple representation of a service detection result
    """ # noqa: E501
    uuid: StrictStr = Field(description="The primary key")
    attack: StrictStr = Field(description="The attack which produced this result")
    created_at: datetime = Field(description="The point in time, this result was produced")
    certainty: StrictStr = Field(description="The certainty a service is detected")
    service_names: List[StrictStr] = Field(description="The found names of the service")
    host: StrictStr = Field(description="The ip address a port was found on")
    port: StrictInt = Field(description="Port number")
    __properties: ClassVar[List[str]] = ["uuid", "attack", "created_at", "certainty", "service_names", "host", "port"]

    @field_validator('certainty')
    def certainty_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('Historical', 'SupposedTo', 'MaybeVerified', 'DefinitelyVerified'):
            raise ValueError("must be one of enum values ('Historical', 'SupposedTo', 'MaybeVerified', 'DefinitelyVerified')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of FullServiceDetectionResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of FullServiceDetectionResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "uuid": obj.get("uuid"),
            "attack": obj.get("attack"),
            "created_at": obj.get("created_at"),
            "certainty": obj.get("certainty"),
            "service_names": obj.get("service_names"),
            "host": obj.get("host"),
            "port": obj.get("port")
        })
        return _obj


