# coding: utf-8

"""
    kraken

    The core component of kraken-project

    The version of the OpenAPI document: 0.1.0
    Contact: git@omikron.dev
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, StrictBool, StrictStr
from pydantic import Field
from typing_extensions import Annotated
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class QueryCertificateTransparencyRequest(BaseModel):
    """
    The settings to configure a certificate transparency request
    """ # noqa: E501
    target: StrictStr = Field(description="Domain to query certificates for")
    include_expired: StrictBool = Field(description="Should expired certificates be included as well")
    max_retries: Annotated[int, Field(strict=True, ge=0)] = Field(description="The number of times the query should be retried if it failed.")
    retry_interval: Annotated[int, Field(strict=True, ge=0)] = Field(description="The interval that should be waited between retries.  The interval is specified in milliseconds.")
    workspace_uuid: StrictStr = Field(description="The workspace to execute the attack in")
    __properties: ClassVar[List[str]] = ["target", "include_expired", "max_retries", "retry_interval", "workspace_uuid"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of QueryCertificateTransparencyRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of QueryCertificateTransparencyRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "target": obj.get("target"),
            "include_expired": obj.get("include_expired"),
            "max_retries": obj.get("max_retries"),
            "retry_interval": obj.get("retry_interval"),
            "workspace_uuid": obj.get("workspace_uuid")
        })
        return _obj


