# coding: utf-8

"""
    kraken

    The core component of kraken-project

    The version of the OpenAPI document: 0.1.0
    Contact: git@omikron.dev
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
from kraken_sdk.models.attack_type import AttackType
from kraken_sdk.models.simple_user import SimpleUser
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class SimpleAttack(BaseModel):
    """
    A simple version of an attack
    """ # noqa: E501
    uuid: StrictStr = Field(description="The identifier of the attack")
    workspace_uuid: StrictStr = Field(description="The workspace this attack is attached to")
    attack_type: AttackType
    started_by: SimpleUser
    finished_at: Optional[datetime] = Field(default=None, description="If this is None, the attack is still running")
    error: Optional[StrictStr] = Field(default=None, description="If this field is set, the attack has finished with an error")
    created_at: datetime = Field(description="The point in time this attack was started")
    __properties: ClassVar[List[str]] = ["uuid", "workspace_uuid", "attack_type", "started_by", "finished_at", "error", "created_at"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of SimpleAttack from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of started_by
        if self.started_by:
            _dict['started_by'] = self.started_by.to_dict()
        # set to None if finished_at (nullable) is None
        # and model_fields_set contains the field
        if self.finished_at is None and "finished_at" in self.model_fields_set:
            _dict['finished_at'] = None

        # set to None if error (nullable) is None
        # and model_fields_set contains the field
        if self.error is None and "error" in self.model_fields_set:
            _dict['error'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of SimpleAttack from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "uuid": obj.get("uuid"),
            "workspace_uuid": obj.get("workspace_uuid"),
            "attack_type": obj.get("attack_type"),
            "started_by": SimpleUser.from_dict(obj.get("started_by")) if obj.get("started_by") is not None else None,
            "finished_at": obj.get("finished_at"),
            "error": obj.get("error"),
            "created_at": obj.get("created_at")
        })
        return _obj


